--[[Concept: Show bars on alt,shift etc.]]
	
KM={}
	
function KM.initialise()
	KM.Dummy=Turbine.UI.Control()
	KM.Dummy:SetWantsUpdates(true)
	
	KM.Dummy.Update = function(sender, args)
		KM.Shift=	KM.Dummy:IsShiftKeyDown()
		KM.Alt=		KM.Dummy:IsAltKeyDown()
		KM.Control=	KM.Dummy:IsControlKeyDown()
		KM.None=	not(KM.Shift or KM.Alt or KM.Control)
		for i=1,#Bar do
			if Bar[i].Data.KM~=nil then
				local k
				k=true --Default to showing
				if Bar[i].Data.KM.Shift then
					k=k and KM.Shift
				end
				if Bar[i].Data.KM.Alt then
					k=k and KM.Alt
				end
				if Bar[i].Data.KM.Control then
					k=k and KM.Control
				end
				if Bar[i].Data.KM.None then
					k=k and KM.None
				end
				Bar[i].KMShow=k
				if k then Bar[i]:Show() else Bar[i]:Hide() end
			end
		end
	end
end

KM.initialise()


--Now the options dialog portions.
function KMOptions(self,contextMenu,contextMenuItems)
	local KMBar= Turbine.UI.MenuItem( "Key Modifiers;");
		contextMenu.Mount = KMBar:GetItems()
		
		local val=self.Data.Mount
		local KMBarMenu={}
			local k
			if self.Data.KM==nil then k={false,false,false,false} else k={self.Data.KM.Shift,self.Data.KM.Alt,self.Data.KM.Control,self.Data.KM.None} end

			KMBarMenu[1]=Turbine.UI.MenuItem("Show on shift",true,k[1])
			KMBarMenu[1].Click=function()
				if self.Data.KM==nil then self.Data.KM={} end
				if self.Data.KM.Shift then self.Data.KM.Shift=nil KMCheck(self)return end
				self.Data.KM.None=nil self.Data.KM.Shift=true 
			end
			
			contextMenu.Mount:Add(KMBarMenu[1])
			
			KMBarMenu[2]=Turbine.UI.MenuItem("Show on alt",true,k[2])
			KMBarMenu[2].Click=function() 
				if self.Data.KM==nil then self.Data.KM={} end 
				if self.Data.KM.Alt then self.Data.KM.Alt=nil KMCheck(self) return end
				self.Data.KM.None=nil self.Data.KM.Alt=true 
			end
			contextMenu.Mount:Add(KMBarMenu[2])
			
			KMBarMenu[3]=Turbine.UI.MenuItem("Show on control",true,k[3])
			KMBarMenu[3].Click=function()
				if self.Data.KM==nil then self.Data.KM={} end 
				if self.Data.KM.Control then self.Data.KM.Control=nil KMCheck(self) return end
				self.Data.KM.None=nil self.Data.KM.Control=true 
			end
			contextMenu.Mount:Add(KMBarMenu[3])
			
			KMBarMenu[4]=Turbine.UI.MenuItem("Hide if any modifier is pressed",true,k[4])
			KMBarMenu[4].Click=function()
				if self.Data.KM==nil then self.Data.KM={} end
				if self.Data.KM.None then self.Data.KM=nil KMCheck(self) return end
				self.Data.KM=nil self.Data.KM={} self.Data.KM.None=true 
			end
			contextMenu.Mount:Add(KMBarMenu[4])
			
			KMBarMenu[7]=Turbine.UI.MenuItem("Clear setting",true)
			KMBarMenu[7].Click=function() self.Data.KM=nil end
			contextMenu.Mount:Add(KMBarMenu[7])			
		
	contextMenuItems:Add( KMBar )
end

function KMCheck(self) 
	if self.Data.KM==nil then return end
	if self.Data.KM.Shift==nil and self.Data.KM.Alt==nil and self.Data.KM.Control==nil and self.Data.KM.None==nil then self.Data.KM=nil end
end

table.insert(Opt.Module,
	function()

	Opt.KMBox=CollapseBox("Key modifier Options","f",1,true)
	
	Opt.ListBox:AddItem(Opt.KMBox)
	
	table.insert(Opt.source,"KM")
	Opt.table.KM=true
	
	Opt.KM=Dummy()

	Opt.KM.Shift=Opt.CheckBox("Show on Shift",		function(k,i)	if Bar[i].Data.KM==nil then Bar[i].Data.KM={} end Bar[i].Data.KM.None=nil Bar[i].Data.KM.Shift=k KMCheck(Bar[i]) end)
	Opt.KMBox.Content:AddItem(Opt.KM.Shift)
	Opt.KM.Control=Opt.CheckBox("Show on Control",	function(k,i)	if Bar[i].Data.KM==nil then Bar[i].Data.KM={} end Bar[i].Data.KM.None=nil Bar[i].Data.KM.Control=k KMCheck(Bar[i]) end)
	Opt.KMBox.Content:AddItem(Opt.KM.Control)
	Opt.KM.Alt=Opt.CheckBox("Show on Alt",			function(k,i)	if Bar[i].Data.KM==nil then Bar[i].Data.KM={} end Bar[i].Data.KM.None=nil Bar[i].Data.KM.Alt=k KMCheck(Bar[i]) end)
	Opt.KMBox.Content:AddItem(Opt.KM.Alt)
	Opt.KM.None=Opt.CheckBox("Hide if any modifier is pressed",			
													function(k,i)	Bar[i].Data.KM=nil Bar[i].Data.KM={} Bar[i].Data.KM.None=k KMCheck(Bar[i]) end)
	Opt.KMBox.Content:AddItem(Opt.KM.None)
	
	Opt.KMClear=Turbine.UI.Lotro.Button()
	Opt.KMClear:SetText("Show in all KMs")
	Opt.KMClear.MouseDown=function() 
		for i=1,#Bar do
			if Bar[i].delete==false then
				if Bar[i].Checked then
					Bar[i].Data.KM=nil
					Bar[i]:Show()
					KMCheck(Bar[i])
				end
			end
		end
		Opt.Update()
	end
	Opt.KMBox.Content:AddItem(Opt.KMClear)

	end)

table.insert(Opt.Updaters, 
	function()
		if Opt.KM~=nil then
			
				Opt.KM.Shift:SetBackColor(nil)
				if Opt.tab.KM.Shift then Opt.KM.Shift:SetVal(true) else Opt.KM.Shift:SetVal(false) end
				if Opt.Check.KM.Shift then Opt.KM.Shift:SetBackColor(Turbine.UI.Color(1,0.3,0.3,0.3)) end
				
				Opt.KM.Control:SetBackColor(nil)
				if Opt.tab.KM.Control then Opt.KM.Control:SetVal(true) else Opt.KM.Control:SetVal(false) end
				if Opt.Check.KM.Control then Opt.KM.Control:SetBackColor(Turbine.UI.Color(1,0.3,0.3,0.3)) end
				
				Opt.KM.Alt:SetBackColor(nil)
				if Opt.tab.KM.Alt then Opt.KM.Alt:SetVal(true) else Opt.KM.Alt:SetVal(false) end
				if Opt.Check.KM.Alt then Opt.KM.Alt:SetBackColor(Turbine.UI.Color(1,0.3,0.3,0.3)) end
				
				Opt.KM.None:SetBackColor(nil)
				if Opt.tab.KM.None then Opt.KM.None:SetVal(true) else Opt.KM.None:SetVal(false) end
				if Opt.Check.KM.None then Opt.KM.None:SetBackColor(Turbine.UI.Color(1,0.3,0.3,0.3)) end
				
		end
	end)